"""
@Name: StatTest
@Author:Jun Ding
@Date: Mar.3,2011
@Version: 1.0
module 1: HyperGeometricTest
function: perform hypergeometric testing to get the p-value
usage:
python HyperGeometricTest(N,M,n,m)

module 2: pbinom
function:compute the cumulative probability densiuty function of the binomial distribution up P(X<=x)

"""
import math
def logc(a,b):
	s=0
	for k in range(b):
		s=s+math.log(float(a-k)/float(b-k))
	return s

def p(N,M,n,m,t):
	bot=logc(N,M)
	top1=logc(n,t)
	top2=logc(N-n,M-t)
	r=top1+top2-bot
	r=math.exp(r)
	return r

def HyperGeometricTest(N,M,n,m):
        p_i=0
	stop=min(M,n)
        for t in range(m,stop+1):
                p_i=p_i+p(N,M,n,m,t)
        return min(p_i,1.0)

def pbinom(x,n,p):
	q=1.0-p
	pdf=cdf=q**n
	f=p/q
	for i in range(1,x+1):
		pdf*=((n-i+1.0)/i*f)
		cdf+=pdf
	return cdf

def binomial(G,k):
	if k==0 or k==G:
		return 1
	elif k>G:
		print('error!')
	else:
		fact=1
		for i in range(0,k):
			up=G-i
			down=k-i
			divid=float(up)/down
			fact=fact*divid
		return fact



