"""
Author: Jun Ding
Date: May 31, 2011
Version: 1.1
Function: This code is used to get the Cis-regulatory modules for given sequences.
Usage: python crm.py <input_seq_file><support_value><p_value cutoff><output_folder_name>
"""
#! /usr/bin/python
import sys,pdb,os,getopt
sys.path.append('code')
import Motif,rmRepeat
from Motif import *
from rmRepeat import *
try:
	opt,args=getopt.getopt(sys.argv[1:],"i:s:c:o:")
	flag=0
	for i in opt:
		if i[0]=='-i':
			sys.argv[1]=i[1]
			flag+=1
		if i[0]=='-s':
			sys.argv[2]=i[1]
			flag+=1
		if i[0]=='-c':
			sys.argv[3]=i[1]
			flag+=1
		if i[0]=='-o':
			sys.argv[4]=i[1]
			flag+=1
	if flag>=4:
		#creat output dir- and move input seq to the output dir--------
		if os.path.exists(sys.argv[4]):
			os.system("rm -r "+sys.argv[4])
		os.mkdir(sys.argv[4])
		fn=sys.argv[1].split('/')[-1]
		os.system("cp "+sys.argv[1]+" "+sys.argv[4]+'/')
		#convert line format-----------------------------------------
		inputseq=sys.argv[4]+'/'+fn
		#pdb.set_trace()
		os.system("python code/SEQProcess.py -m 3 "+inputseq)
		os.system("rm "+inputseq)
		os.system("mv "+inputseq+"_LineFormat"+" "+inputseq)
		os.system("echo 'begin scanning sequences'")
		os.system("python code/Motif.py -m 1 "+inputseq+" "+"data/normalized_transfac_matrices")
		scanout1=inputseq+"_MotifHits"
		scanout2=inputseq+"_MotifHitsPositions"
		#pdb.set_trace()
		#removing redundant motifs------------------------------------------------------------------------------
		os.system("echo 'removing redundant motif hits...'")
		os.system("python code/Motif.py -m 4 "+"data/normalized_transfac_matrices"+" "+scanout1+" "+scanout2+" "+"4")
		non=scanout1+"_4_non_redundant"
		non2=scanout2+"_4_non_redundant"
		os.remove(scanout1)
		os.remove(scanout2)
		
		#------removing repeat hits----------------------------------------------------------------------------
		os.system("python code/rmRepeat.py "+non)
		nre=non+"_repeat_removed"
		#------FIM---------------------------------------------------------------------------------------------------
		os.system("chmod +x code/fim_maximal")
		os.system("echo 'generating candidate motif modules...'")
		trans=nre
		out_trans=nre+"_candidate_modules"
		os.system("./code/fim_maximal "+trans+" "+sys.argv[2]+" "+out_trans)
		#------Statistical evaluation-----------------------------------------------------------------------------------------------
		os.system("echo 'statistical evaluation...'")
		os.system(" python code/pgc.py "+out_trans+" "+"data/lambda"+" "+"data/normalized_transfac_matrices"+" "+inputseq+" "+sys.argv[3])
		out_pgc=out_trans+"_significant"
		out_pgc_2=out_trans+"_corrected_pvalue"
		#pdb.set_trace()
		#-----Motif ID convertion-----------------------------------------------------------------------------------------------------------
		os.system("python code/sig_module_pvalue.py "+out_pgc+" "+out_pgc_2)
		os.system("rm "+out_trans)
		os.system("rm "+out_pgc_2)
		os.system("rm "+non)
		os.system("rm "+non2)
		#----get target genes-----------------------------------------------------------------------------------------------------------------------
		os.system("python code/module_target_gene.py "+out_pgc+" "+trans+" "+inputseq+"_GeneName")
		out_target=out_pgc+"_target_genes"
		#----clear all tmp files--------------------------------------------------------------------------------------------------------------------
		
		#pdb.set_trace()
		inputname=inputseq.split('/')[-1]
		os.system("python code/convert_motif_id.py "+out_pgc+" "+"data/lambda" )
		os.system("rm "+inputseq+"_GeneName")
		os.system("rm "+nre)
		os.system("rm "+inputseq)
		os.system("mv "+out_pgc+" "+sys.argv[4]+"/"+"significant_modules_"+inputname)
		os.system("mv "+out_target+" "+sys.argv[4]+"/"+"module_target_genes_"+inputname)
	else:
		print("python crm.py -i <input sequence> -s <support value for frequent pattern mining> -c <pvalue cutoff > -o <output file>")
except:
	print("python crm.py -i <input sequence> -s <support value for frequent pattern mining> -c <pvalue cutoff > -o <output file>")
	





