package mpredict;

import java.util.Comparator;

/*** Scored by motif sequence segment ***/
  public class MotifScore implements Comparable<MotifScore>{
    static int sid=0;
    int id;
    PWM motif;
    Sequence seq;
    Sequence.SequenceStrand strand;
    int offset;
    float score;
    
    public MotifScore(PWM motif, Sequence s, Sequence.SequenceStrand strand, int offset, float score) {
        sid++;
        this.id = sid;
        this.motif = motif;
        this.seq = s;
        this.strand = strand;
        this.offset = offset;
        this.score = score;
    }    
    
    
    public String toString(){   
        //We add one to motif key to return line numbers start at 1 not 0
        return (motif.getID()+1)+"\t"+strand+"\t"+offset+"\t"+String.format("%6.4f", score)+"\t";
    }

   /**
   * Sorts according to motifKey
   * @param o
   * @return
   */
    public int compareTo(MotifScore o) {
      byMotifPosition pos = new byMotifPosition();
      return (this.motif.getID() < o.motif.getID() ? -1 : (this.motif.getID() == o.motif.getID() ? pos.compare(this, o) : 1));
    }
      
    protected static class byMotifPosition implements Comparator<MotifScore>{
        public int compare(MotifScore a, MotifScore b){
          return (a.offset < b.offset ? -1 : (a.offset == b.offset ? 0 : 1));
        }
    }       

    protected static class byMotifScoreDesc implements Comparator<MotifScore>{
        public int compare(MotifScore a, MotifScore b){
          return (a.score == b.score ? 0 : (a.score < b.score ? 1 : -1));  
        }
    }  

}
