package mpredict;
import java.io.IOException;

import java.util.Comparator;

public class SequenceFASTA extends Sequence implements Comparable<SequenceFASTA>, Cloneable {
        private String chr;
        private long start=0;
        private long end=0;
        
        protected SequenceFASTA(){}
        
        protected SequenceFASTA(String attributes) throws IOException{
            this.setAttributes(attributes);
        }
        
        protected void setAttributes(String attributes) throws IOException, NumberFormatException{
            if (attributes.startsWith(">"))
            {
                header = attributes;
            }
            else{
                throw new IOException("This sequence's attributes are not formatted correctly="+attributes);
            }
        }          
        
        public int compareTo(SequenceFASTA t) {
            int chr_num=0;
            int tchr_num=0;
            try{
                chr_num= Integer.parseInt(chr.substring(3));
            }
            catch(NumberFormatException ex) {
                char c = chr.toLowerCase().charAt(chr.length()-1);
                if ( c == 'x' || c== 'y' )
                    chr_num = c;
                else throw new NumberFormatException("Error unknown chromosome "+chr+"!\n"+ex.getMessage());
            }
            try{
                tchr_num= Integer.parseInt(t.chr.substring(3));
            }
            catch(NumberFormatException ex) {
                char c = t.chr.toLowerCase().charAt(t.chr.length()-1);
                if ( c == 'x' || c== 'y' )
                    tchr_num = c;
                else throw new NumberFormatException("Error unknown chromosome "+t.chr+"!\n"+ex.getMessage());
            }
            if (chr_num == tchr_num)
                return (this.start < t.start ? -1 : (this.start == t.start ? (this.end <= t.end ? -1 : 1) : 1));
            else
                return (chr_num < tchr_num ? -1 : 1);
        }
        
        protected Object clone() throws CloneNotSupportedException{
          SequenceFASTA clone=(SequenceFASTA)super.clone();
          return clone;
        }     
}
