package mpredict;

import java.io.IOException;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import java.util.Random;

public class SequenceRANDOM extends Sequence {
  
  protected SequenceRANDOM(){}
  
  protected SequenceRANDOM(String header) throws IOException {
    setAttributes(header);
  }
  
  
  /**
  * Create Long Sequence from Random Sequence File of particular size
  * @param collection extending Sequence
  * @param randSize
  * @throws IOException
  */
  public SequenceRANDOM(Collection<? extends Sequence> aSequences, int randSize) throws IOException{
    header = ">Random background";
    StringBuilder sb = new StringBuilder();
    if(aSequences.size()<1)
        return;
    
    if(randSize < 1){
      for(Sequence t : aSequences){
        randSize += t.sequence.length();
      }
    }
    
    // Shuffle list objects
    List<Sequence> SeqR = new ArrayList<Sequence>(aSequences);
    Random rand = new Random(randSize);
    //Collections.shuffle(SeqR, rand);
    
    // Create long sequence from input
    while(sb.length() < randSize){
        for(Sequence r : SeqR){
          for(int i=0; i< r.sequence.length(); i++){
            char c= r.sequence.charAt(i);
            sb.append(c);
            if(sb.length() >= randSize)
                break;
          }
        }
    }
    //sb = shuffle(sb);
    sequence = sb.toString();
  }
  
  protected void setAttributes(String attributes) throws IOException, NumberFormatException{
      if (attributes.startsWith(">"))
      {
          header = attributes;
      }
      else{
          throw new IOException("Failed to create random sequence\n The attributes are not formatted correctly="+attributes);
      }
  }
  
}
